#pragma once

#ifndef __D12_D2D_GRAPH__
#define __D12_D2D_GRAPH__

#include <Windows.h>
#include <VersionHelpers.h>

#include <d2d1_3.h>
#include <dwrite.h>
#include <d3d11on12.h>
#include <d3d12.h>
#include <dxgi1_6.h>
#include <D3Dcompiler.h>
#include <DirectXMath.h>

#include <S:\Engine\Graphics\d3dx12.h>

#include <wrl.h>

#include <Wincodec.h>

#include <vector>

struct Control {
	bool Border{ false };
	Microsoft::WRL::ComPtr<ID2D1SolidColorBrush> BorderBrush{ nullptr };
	Microsoft::WRL::ComPtr<ID2D1SolidColorBrush> pTextBrush{ nullptr };
	Microsoft::WRL::ComPtr<IDWriteTextFormat> pTextFormat{ nullptr };
	
	std::wstring text{ L"Hello World!" };
};

class D2DGraphics {
public:
	D2DGraphics();
	~D2DGraphics();
private:
	Microsoft::WRL::ComPtr<ID3D11DeviceContext> pD3D11DeviceContext{ nullptr };
	Microsoft::WRL::ComPtr<ID3D11On12Device> pD3D11On12Device{ nullptr };
	Microsoft::WRL::ComPtr<ID2D1DeviceContext2> pD2DDeviceContext{ nullptr };

	Microsoft::WRL::ComPtr<ID2D1Bitmap1> pD2DRenderTargets[3]{ nullptr };
	Microsoft::WRL::ComPtr<ID3D11Resource> pWrappedBackBuffers[3]{ nullptr };

	Microsoft::WRL::ComPtr<ID3D11Device> d3d11Device{ nullptr };
	Microsoft::WRL::ComPtr<IDWriteFactory> pDWriteFactory{ nullptr };
	Microsoft::WRL::ComPtr<ID2D1Device2> pD2DDevice{ nullptr };

	Microsoft::WRL::ComPtr<ID2D1Factory3> pD2DFactory{ nullptr };

	Microsoft::WRL::ComPtr<IWICImagingFactory> m_pWICFactory{ nullptr };
	D2D1_FACTORY_OPTIONS d2dFactoryOptions{};

	Control Static{};

public:
	bool InitD2D(ID3D12Device *pDevice, Microsoft::WRL::ComPtr<ID3D12CommandQueue> pCommandQueue, Microsoft::WRL::ComPtr<ID3D12Resource> Res[]);
	void RenderD2D(int FrameIndex);
};

#endif __D12_D2D_GRAPH__